
/*
 * $Id: CltCfg.cc,v 1.1.2.1 1999/11/06 00:35:09 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "PopModel.h"
#include "RobotSym.h"
#include "CltCfg.h"


CltCfg::CltCfg(): theOriginSel(0), thePopModel(0),
	thePublicRatio(-1), theRecurRatio(-1), theEmbedRecurRatio(-1),
	theWaitXactLmt(-1), theSrvCount(0), genUniqUrls(false) {
}

void CltCfg::configure(const RobotSym *cfg) {
	cfg->waitXactLimit(theWaitXactLmt);

	theLaunchWin = cfg->launchWin();
	cfg->publicRatio(thePublicRatio);
	cfg->recurRatio(theRecurRatio);
	cfg->embedRecurRatio(theEmbedRecurRatio);
	thePopModel = cfg->popModel();
	cfg->uniqueUrls(genUniqUrls);

	if (!thePopModel && theRecurRatio > 0) {
		cerr << cfg->loc() << "popularity model must be specified for"
			<< " positive recurrence ratio (robot " << cfg->kind() << ')'
			<< endl;
		exit(-2);
	}	
}

