
/*
 * $Id: CltXact.h,v 1.7.2.2 1999/10/23 23:11:39 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef CLT_XACTION_H
#define CLT_XACTION_H

#include "httpHdrs.h"
#include "Xaction.h"

class Client;
class ServerRep;
class WrBuf;

class CltXact: public Xaction {
	public:
		CltXact() { reset(); }

		void reset();

		void enqueue();
		void exec(Client *anOwner, Connection *aConn);

		virtual void noteReadReady(int fd);
		virtual void noteWriteReady(int fd);

	protected:
		virtual Agent *owner();

		void makeReq(WrBuf &buf);
		int interpretHeader();
		Size parseContent();
		void parseTag(const char *tagB, const char *tagE);
		void finish(int errNo);

		void consume(Size size);

	protected:
		Client *theOwner;
		ServerRep *theSrvRep;
		RepHdr theRepHdr;
		Size theConsumedSize;

		int theOidShortage; // how many new oids we have asked for
};

#endif
