
/*
 * $Id: ErrorLx.h,v 1.1.2.1 1999/11/20 18:10:57 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_ERROR_STAT_LOG_EXTRACTOR_H
#define PG_ERROR_STAT_LOG_EXTRACTOR_H

#include "ErrorStat.h"
#include "ErrorStrTbl.h"
#include "LogExtractor.h"

class ErrorLxRec: public LxRec {
	public:
		virtual const ErrorStat &errorStat() const { return theStat; }

	protected:
		virtual const char *type() const { return "error"; }

	public:
		static ErrorStrTbl TheStrs; // one for all

	public:
		ErrorStat theStat;
};

class ErrorLx: public LogExtractor {
	private:
		typedef void (ErrorLx::*Exor)(const ErrorStat &es, ostream &os) const;

	public:
		ErrorLx();

		virtual bool configure(const String &aName, const LxParams &params);
		virtual void extract(const LxRec &r, ostream &os);

	protected:
		void exErrorH(const ErrorStat &es, ostream &os) const;

	private:
		Exor theExor; // set at configure time
};

#endif
