
/*
 * $Id: AgentArrIter.cc,v 1.1.2.2 1999/10/31 03:09:56 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "AgentSym.h"
#include "AgentArrIter.h"


AgentArrIter::AgentArrIter(CfgSyms &aCfgSyms, const Addrs *aLocalAddrs, const String &anAgentType):
	theAgentType(anAgentType) {
	theCfgs = aCfgSyms; 
	start(aLocalAddrs);
}

AgentSym *AgentArrIter::agentSym() {
	return &(AgentSym&)cfgSym(theCfgIdx)->cast(theAgentType);
}

HostsBasedSym *AgentArrIter::cfgSym(int idx) const {
	return theCfgs[idx];
}

int AgentArrIter::cfgCount() const {
	return theCfgs.count();
}

bool AgentArrIter::belongs(const HostsBasedSym *cfgSym, const NetAddr &host) const {
	return cfgSym->isA(theAgentType) &&
		HostsBasedIter::belongs(cfgSym, host);
}
