
/*
 * $Id: MimeSym.cc,v 1.3 1999/09/07 17:47:39 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "String.h"
#include "PglRec.h"
#include "PglStringSym.h"
#include "MimeSym.h"


MimeSym::MimeSym(): RecSym("Mime", new PglRec) {

	// add fields

	theRec->bAdd("string", "type", 0);
	theRec->bAdd("string[]", "extensions", 0);
}

MimeSym::MimeSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool MimeSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "Mime";
}

SynSym *MimeSym::clone(const String &type) const {
	if (isA(type))
		return new MimeSym(this->type(), theRec->clone());
	return RecSym::clone(type);
}

String MimeSym::mimeType() const {
	SynSymTblItem *ti = 0;
	Assert(theRec);
	Assert(theRec->find("type", ti));
	return ti->sym() ?
		((const StringSym&)ti->sym()->cast("string")).val() : String(0);
}
