
/*
 * $Id: Lexer.h,v 1.3 1999/09/07 17:48:20 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef XPARSER_LEXER_H
#define XPARSER_LEXER_H

#include "LexToken.h"

// generic lexer
class Lexer {
	public:
		virtual ~Lexer() {}

		const LexToken &nextToken() { return(theToken = scan()); }
		const LexToken &token() const { return theToken; }

		int symbol() const { return token().id(); };
		const String &spelling() const { return token().spell(); }

	protected:
		virtual LexToken scan() = 0;

	protected:
		LexToken theToken;
};

#endif
